﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

using Infragistics.Controls.Menus;

namespace WpfApplication3
{
	public class NodeData
	{
		public string text;
	}

	public class MasterDetailDataItem
	{
		#region Fields (8) 

		private MasterDetailDataItem       detailData     = null;
		private List<MasterDetailDataItem> detailDataList = new List<MasterDetailDataItem>();
		private DataRowView                masterData     = null;

		#endregion Fields 


		#region Constructors (1) 

		public MasterDetailDataItem()
		{
		}

		#endregion Constructors 


		#region Properties (8) 

		public MasterDetailDataItem DetailData
		{
			get
			{
			    return this.detailData;
			}
		    set
		    {
		        this.detailData = value;
		    }
		}

		public List<MasterDetailDataItem> DetailDataList
		{
		    get
		    {
		        return this.detailDataList;
		    }
		    set
		    {
		        this.detailDataList = value;
		    }
		}

		public DataRowView MasterData
		{
		    get
		    {
		        return this.masterData;
		    }
		    set
		    {
		        this.masterData = value;
		    }
		}

		#endregion Properties 
	}

	public class MasterDetailData
	{
		#region Fields (1) 

		private List<MasterDetailDataItem> masterDetailDataList = new List<MasterDetailDataItem>();

		#endregion Fields 


		#region Constructors (1) 

		public MasterDetailData()
		{
		}

		#endregion Constructors 


		#region Properties (1) 

		public List<MasterDetailDataItem> MasterDetailDataList
		{
		    get
		    {
		        return this.masterDetailDataList;
		    }
		    set
		    {
		        this.masterDetailDataList = value;
		    }
		}

		#endregion Properties 
	}

	/// <summary>
	/// Interaktionslogik für MainWindow.xaml
	/// </summary>
	public partial class MainWindow : Window
	{
		public MainWindow()
		{
			InitializeComponent();

			// If I call this method for every node and set the IsExpanded to true, then the child nodes are not visisble
			// although the node seems expanded

			// If I do not call this method, then the root node is not expanded

			// In the last version, before 2125 it works

			Tree.InitializeNode += new EventHandler<Infragistics.Controls.Menus.InitializeNodeEventArgs>(OnDataTreeInitializeNode);

			List<MasterDetailDataItem> data;

			// In my application I query the data from a database
			// Here in the example I created two simple tables

			DataTable                  dtRoot;
			DataTable                  dtChilds;
			DataRow                    drRoot;
			DataRow                    drChilds;
			DataView                   dvRoot;
			DataView                   dvChilds;

			dtRoot = new DataTable();
			dtRoot.Columns.Add("text", System.Type.GetType("System.String"));

			dtChilds = new DataTable();
			dtChilds.Columns.Add("text", System.Type.GetType("System.String"));

			drRoot    = dtRoot.NewRow();
			drRoot[0] = "Root";
			dtRoot.Rows.Add(drRoot);

			drChilds    = dtChilds.NewRow();
			drChilds[0] = "Child 1";
			dtChilds.Rows.Add(drChilds);

			drChilds    = dtChilds.NewRow();
			drChilds[0] = "Child 2";
			dtChilds.Rows.Add(drChilds);

			dvRoot   = dtRoot.DefaultView;
			dvChilds = dtChilds.DefaultView;

			data = new List<MasterDetailDataItem>();

			for (int i = 0; i < dvRoot.Count; i++)
			{
				MasterDetailDataItem root;

				root                = new MasterDetailDataItem();
				root.MasterData     = dvRoot[i];
				root.DetailDataList = new List<MasterDetailDataItem>();

				for (int j = 0; j < dvChilds.Count; j++)
				{
					MasterDetailDataItem child;

					child                = new MasterDetailDataItem();
					child.MasterData     = dvChilds[j];
					child.DetailDataList = new List<MasterDetailDataItem>();

					root.DetailDataList.Add(child);
				}

				data.Add(root);
			}

			Tree.ItemsSource = data;
		}

		private void OnDataTreeInitializeNode(object sender, Infragistics.Controls.Menus.InitializeNodeEventArgs e)
		{
			// For each Node I set the IsExpanded Property
			// Here in the example all trees are expanded

			e.Node.IsExpanded = true;
		}
	}
}
